function judgeType(obj, type) {
    type = type.substr(0, 1).toUpperCase() + type.substr(1);
    return Object.prototype.toString.call(obj) === "[object " + type + "]";
}
function getDevice() {
    var ua = navigator.userAgent;
    var isWindowsPhone = /(?:Windows Phone)/.test(ua);
    var isSymbian = /(?:SymbianOS)/.test(ua) || isWindowsPhone;
    var isAndroid = /(?:Android)/.test(ua);
    var isFireFox = /(?:Firefox)/.test(ua);
    var isChrome = /(?:Chrome|CriOS)/.test(ua);
    var isTablet =
        /(?:iPad|PlayBook)/.test(ua) ||
        (isAndroid && !/(?:Mobile)/.test(ua)) ||
        (isFireFox && /(?:Tablet)/.test(ua));
    var isPhone = /(?:iPhone)/.test(ua) && !isTablet;
    var isPc = !isPhone && !isAndroid && !isSymbian;
    return { isTablet, isPhone, isAndroid, isPc, isChrome };
}
var MouseMove = function(config) {
    var _config = Object.assign({}, { type: "move", coefficient: 40, domClass: ".j-move-item" }, config);
    var os = getDevice();
    var sceen = { width: 0, height: 0, centerX: 0, centerY: 0, gamma: 0, beta: 0 };
    var mousePosition = { x: 0, y: 0 };
    var deviceOrientation = { gamma: 0, beta: 0 };
    var domList,
        domListCoefficient = [];
    var moveItem = function(dom) {
        var len = dom.length;
        var domItem, translateX, translateY, rotateX, rotateY;
        var isArray = judgeType(_config.coefficient, "array");
        var coefficientLen = isArray ? _config.coefficient.length : 0;
        var genFixedPosition = function() {
            if (os.isPc) {
                if (_config.type === "move") {
                    translateX = (mousePosition.x - sceen.centerX) / _config.coefficient;
                    translateY = (mousePosition.y - sceen.centerY) / _config.coefficient;
                } else if (_config.type === "rotate") {
                    translateX = (mousePosition.x - sceen.centerX) / 100;
                    rotateX = ((mousePosition.y - sceen.centerY) / (sceen.centerY * _config.coefficient)) * 360;
                    rotateY = ((mousePosition.x - sceen.centerX) / (sceen.centerX * _config.coefficient)) * 360;
                }
            } else {
                if (_config.type === "move") {
                    translateX = (deviceOrientation.gamma - sceen.gamma) / (_config.coefficient / 10);
                    translateY = (deviceOrientation.beta - sceen.beta) / (_config.coefficient / 10);
                } else if (_config.type === "rotate") {
                    translateX = (deviceOrientation.gamma - sceen.gamma) / 10;
                    rotateX = (deviceOrientation.beta - sceen.beta) / (_config.coefficient / 10);
                    rotateY = (deviceOrientation.gamma - sceen.gamma) / (_config.coefficient / 10 - 1);
                }
            }
        };
        var genRandomPosition = function() {
            var coefficient;
            if (os.isPc) {
                if (len !== coefficientLen) {
                    if (domListCoefficient.length === len) {
                        coefficient = domListCoefficient[i];
                    } else {
                        coefficient = _config.coefficient[Math.floor(Math.random() * coefficientLen)];
                        domListCoefficient[i] = coefficient;
                    }
                } else {
                    coefficient = _config.coefficient[i];
                }
                if (_config.type === "move") {
                    translateX = (mousePosition.x - sceen.centerX) / coefficient;
                    translateY = (mousePosition.y - sceen.centerY) / coefficient;
                } else if (_config.type === "rotate") {
                    translateX = (mousePosition.x - sceen.centerX) / 100;
                    rotateY = ((mousePosition.x - sceen.centerX) / (sceen.centerX * coefficient)) * 360;
                    rotateX = ((mousePosition.y - sceen.centerY) / (sceen.centerY * coefficient)) * 360;
                }
            } else {
                if (len !== coefficientLen) {
                    if (domListCoefficient.length === len) {
                        coefficient = domListCoefficient[i];
                    } else {
                        coefficient = _config.coefficient[Math.floor(Math.random() * coefficientLen)];
                        domListCoefficient[i] = coefficient;
                    }
                } else {
                    coefficient = _config.coefficient[i];
                }
                if (_config.type === "move") {
                    translateX = (deviceOrientation.gamma - sceen.gamma) / (coefficient / 10);
                    translateY = (deviceOrientation.beta - sceen.beta) / (coefficient / 10);
                } else if (_config.type === "rotate") {
                    translateX = (deviceOrientation.gamma - sceen.gamma) / 10;
                    rotateX = (deviceOrientation.beta - sceen.beta) / (_config.coefficient / 10);
                    rotateY = (deviceOrientation.gamma - sceen.gamma) / (_config.coefficient / 10 - 1);
                }
            }
        };
        if (!isArray) {
            genFixedPosition();
        }
        for (var i = 0; i < len; i++) {
            domItem = dom[i];
            if (isArray) {
                genRandomPosition();
            }
            if (_config.type === "move") {
                domItem.style.transform = "translate(" + translateX + "px, " + translateY + "px) translateZ(0)";
            } else if (_config.type === "rotate") {
                domItem.style.transform =
                    "perspective(2500px) translate(" +
                    translateX +
                    "px, 0px) translateZ(0) rotateX(" +
                    rotateX +
                    "deg) rotateY(" +
                    rotateY +
                    "deg)";
            }
        }
    };
    document.addEventListener("DOMContentLoaded", function(e) {
        sceen = {
            width: window.innerWidth,
            height: window.innerHeight,
            centerX: window.innerWidth / 2,
            centerY: window.innerHeight / 2
        };
        domList = document.querySelectorAll(_config.domClass);
        if (os.isPc) {
            window.addEventListener("mousemove", function(e) {
                e = e || window.event;
                mousePosition = { x: e.clientX, y: e.clientY };
                moveItem(domList);
            });
        } else {
            var init = false;
            window.addEventListener(
                "deviceorientation",
                function(e) {
                    e = e || window.event;
                    if (!init) {
                        sceen = { gamma: e.gamma, beta: e.beta };
                        init = true;
                        return;
                    }
                    deviceOrientation = { gamma: e.gamma, beta: e.beta };
                    moveItem(domList);
                },
                false
            );
        }
    });
};

export default MouseMove;
